// Frags animation
// 2010.08.15 first version
//
// Petter Sundnes
// petter@mentalfish.com

@version 2.7
@warnings
@script generic
@asyncspawn
@name MF Keyfragger

ctlPositionX;
ctlPositionY;
ctlPositionZ;
ctlRotationH;
ctlRotationP;
ctlRotationB;
ctlScaleX;
ctlScaleY;
ctlScaleZ;

ctlPosition;
ctlRotation;
ctlScale;

fragPositionX = 1;
fragPositionY = 1;
fragPositionZ = 1;
fragRotationH = 1;
fragRotationP = 1;
fragRotationB = 1;
fragScaleX = 1;
fragScaleY = 1;
fragScaleZ = 1;

fragPos = 1;
fragRot = 1;
fragScl = 1;

toggleXPos: value
{
	fragPositionX = fragPositionX * -1;
	if(fragPositionX == 1 && fragPositionY == 1 && fragPositionZ == 1)
	{
		ctlPosition.value = true;
		fragPos = 1;
	} else {
		ctlPosition.value = false;
		fragPos = -1;
	}
}
toggleYPos: value
{
	fragPositionY = fragPositionY * -1;
	if(fragPositionX == 1 && fragPositionY == 1 && fragPositionZ == 1)
	{
		ctlPosition.value = true;
		fragPos = 1;
	} else {
		ctlPosition.value = false;
		fragPos = -1;
	}

}
toggleZPos: value
{
	fragPositionZ = fragPositionZ * -1;
	if(fragPositionX == 1 && fragPositionY == 1 && fragPositionZ == 1)
	{
		ctlPosition.value = true;
		fragPos = 1;
	} else {
		ctlPosition.value = false;
		fragPos = -1;
	}

}
toggleH: value
{
	fragRotationH = fragRotationH * -1;
	if(fragRotationH == 1 && fragRotationP == 1 && fragRotationB == 1)
	{
		ctlRotation.value = true;
		fragRot = 1;
	} else {
		ctlRotation.value = false;
		fragRot = -1;
	}
}
toggleP: value
{
	fragRotationP = fragRotationP * -1;
	if(fragRotationH == 1 && fragRotationP == 1 && fragRotationB == 1)
	{
		ctlRotation.value = true;
		fragRot = 1;
	} else {
		ctlRotation.value = false;
		fragRot = -1;
	}
}
toggleB: value
{
	fragRotationB = fragRotationB * -1;
	if(fragRotationH == 1 && fragRotationP == 1 && fragRotationB == 1)
	{
		ctlRotation.value = true;
		fragRot = 1;
	} else {
		ctlRotation.value = false;
		fragRot = -1;
	}
}
toggleXScl: value
{
	fragScaleX = fragScaleX * -1;
	if(fragScaleX == 1 && fragScaleY == 1 && fragScaleZ == 1)
	{
		ctlScale.value = true;
		fragScl = 1;
	} else {
		ctlScale.value = false;
		fragScl = -1;
	}
}
toggleYScl: value
{
	fragScaleY = fragScaleY * -1;
	if(fragScaleX == 1 && fragScaleY == 1 && fragScaleZ == 1)
	{
		ctlScale.value = true;
		fragScl = 1;
	} else {
		ctlScale.value = false;
		fragScl = -1;
	}
}
toggleZScl: value
{
	fragScaleZ = fragScaleZ * -1;
	if(fragScaleX == 1 && fragScaleY == 1 && fragScaleZ == 1)
	{
		ctlScale.value = true;
		fragScl = 1;
	} else {
		ctlScale.value = false;
		fragScl = -1;
	}
}

togglePos: value
{
	fragPos = fragPos * -1;
	if(fragPos == 1)
	{
		ctlPositionX.value = true;
		ctlPositionY.value = true;
		ctlPositionZ.value = true;
		fragPositionX = 1;
		fragPositionY = 1;
		fragPositionZ = 1;
	} else if(fragPos == -1) {
		ctlPositionX.value = false;
		ctlPositionY.value = false;
		ctlPositionZ.value = false;
		fragPositionX = -1;
		fragPositionY = -1;
		fragPositionZ = -1;
	}
}
toggleRot: value
{
	fragRot = fragRot * -1;
	if(fragRot == 1)
	{
		ctlRotationH.value = true;
		ctlRotationP.value = true;
		ctlRotationB.value = true;
		fragRotationH = 1;
		fragRotationP = 1;
		fragRotationB = 1;
	} else if(fragRot == -1) {
		ctlRotationH.value = false;
		ctlRotationP.value = false;
		ctlRotationB.value = false;
		fragRotationH = -1;
		fragRotationP = -1;
		fragRotationB = -1;
	}
}
toggleScl: value
{
	fragScl = fragScl * -1;
	if(fragScl == 1)
	{
		ctlScaleX.value = true;
		ctlScaleY.value = true;
		ctlScaleZ.value = true;
		fragScaleX = 1;
		fragScaleY = 1;
		fragScaleZ = 1;
	} else if(fragScl == -1){
		ctlScaleX.value = false;
		ctlScaleY.value = false;
		ctlScaleZ.value = false;
		fragScaleX = -1;
		fragScaleY = -1;
		fragScaleZ = -1;
	}
}

generic
{
	reqbegin("MentalFish Keyfragger");
	reqsize(250,105);
	
	thisScene = Scene(); // Get a reference to the model
	allSceneItems;
	allSceneItems = thisScene.getSelect();
	numberOfItems = sizeof(allSceneItems);
	
	fps = thisScene.fps;
	startTime = thisScene.currenttime;
	startFrame = 0;//startTime*fps;
	
	ctlStartFrame = ctlinteger("Start:", startTime*fps);
	ctlposition(ctlStartFrame,10,5,72,19);
	
	//NextKey();
	endTime = thisScene.frameend/fps;
	ctlEndFrame = ctlinteger("End:", endTime*fps);
	ctlposition(ctlEndFrame,90,5,72,19);
	//GoToFrame(startFrame);

	ctlSkipFrame = ctlinteger("Space:", 0);
	ctlposition(ctlSkipFrame,170,5,72,19);

	ctlPosition = ctlstate("   Position", true, 100, "togglePos");
	ctlposition(ctlPosition,10,30,73,19);
	ctlPositionX = ctlstate(" X", true, 100, "toggleXPos");
	ctlposition(ctlPositionX,10,48,25,19);
	ctlPositionY = ctlstate(" Y", true, 100, "toggleYPos");
	ctlposition(ctlPositionY,34,48,25,19);
	ctlPositionZ = ctlstate(" Z", true, 100, "toggleZPos");
	ctlposition(ctlPositionZ,58,48,25,19);
	
	ctlRotation = ctlstate("   Rotation", true, 100, "toggleRot");
	ctlposition(ctlRotation,90,30,73,19);
	ctlRotationH = ctlstate(" H", true, 100, "toggleH");
	ctlposition(ctlRotationH,90,48,25,19);
	ctlRotationP = ctlstate(" P", true, 100, "toggleP");
	ctlposition(ctlRotationP,114,48,25,19);
	ctlRotationB = ctlstate(" B", true, 100, "toggleB");
	ctlposition(ctlRotationB,138,48,25,19);
	
	ctlScale = ctlstate("     Scale", true, 100, "toggleScl");
	ctlposition(ctlScale,170,30,73,19);
	ctlScaleX = ctlstate(" X", true, 100, "toggleXScl");
	ctlposition(ctlScaleX,170,48,25,19);
	ctlScaleY = ctlstate(" Y", true, 100, "toggleYScl");
	ctlposition(ctlScaleY,194,48,25,19);
	ctlScaleZ = ctlstate(" Z", true, 100, "toggleZScl");
	ctlposition(ctlScaleZ,218,48,25,19);
	
	return if !reqpost();
		frameStart = getvalue(ctlStartFrame);
		frameEnd = getvalue(ctlEndFrame);
		frameSkip = getvalue(ctlSkipFrame);
		fragPositionX = getvalue(ctlPositionX);
		fragPositionY = getvalue(ctlPositionY);
		fragPositionZ = getvalue(ctlPositionZ);
		fragRotationH = getvalue(ctlRotationH);
		fragRotationP = getvalue(ctlRotationP);
		fragRotationB = getvalue(ctlRotationB);
		fragScaleX = getvalue(ctlScaleX);
		fragScaleY = getvalue(ctlScaleY);
		fragScaleZ = getvalue(ctlScaleZ);
	reqend();
	
	pos[numberOfItems][frameEnd-frameStart] = <0,0,0>;
	rot[numberOfItems][frameEnd-frameStart] = <0,0,0>;
	scl[numberOfItems][frameEnd-frameStart] = <0,0,0>;
	
	frameCount = 0;		
	for(f = frameStart; f <= frameEnd; f++)
	{
		time = f / fps;
		
		//GoToFrame(f);
		//RefreshNow(); // Needed to make sure the "state of things" are available

		frameCount++;
		for(itemCnt=1;itemCnt<=numberOfItems;itemCnt++)
		{
			sceneItem = allSceneItems[itemCnt];
			pos[itemCnt][frameCount] = sceneItem.getPosition(time);
			rot[itemCnt][frameCount] = sceneItem.getRotation(time);
			scl[itemCnt][frameCount] = sceneItem.getScaling(time);
			for(chan = sceneItem.firstChannel(); chan != nil; chan = sceneItem.nextChannel())
			{
				if(chan.name == "Position.X")
				    xPosCurve[itemCnt] = chan;
				else if(chan.name == "Position.Y")
				    yPosCurve[itemCnt] = chan;
				else if(chan.name == "Position.Z")
				    zPosCurve[itemCnt] = chan;
				else if(chan.name == "Rotation.H")
				    hRotCurve[itemCnt] = chan;
				else if(chan.name == "Rotation.P")
				    pRotCurve[itemCnt] = chan;
				else if(chan.name == "Rotation.B")
				    bRotCurve[itemCnt] = chan;
				else if(chan.name == "Scale.X")
				    xScaleCurve[itemCnt] = chan;
				else if(chan.name == "Scale.Y")
				    yScaleCurve[itemCnt] = chan;
				else if(chan.name == "Scale.Z")
				    zScaleCurve[itemCnt] = chan;
			}
		}
	}
	for(n = 1; n<=numberOfItems; n++)
	{
		currFrame = 0;
		skipCounter = 0;
		for(f = frameStart;f <= frameEnd;f++)
		{
			time = f / fps;
			currFrame++;
			
			if(skipCounter!=0)
			{
				currKey = xPosCurve[n].keyExists(time);
				if(fragPositionX && currKey!=nil)
					xPosCurve[n].deleteKey(currKey);
					
				currKey = yPosCurve[n].keyExists(time);
				if(fragPositionY && currKey!=nil)
					yPosCurve[n].deleteKey(currKey);
				
				currKey = zPosCurve[n].keyExists(time);
				if(fragPositionZ && currKey!=nil)
					zPosCurve[n].deleteKey(currKey);
			
				currKey = hRotCurve[n].keyExists(time);
				if(fragRotationH && currKey!=nil)
					hRotCurve[n].deleteKey(currKey);
					
				currKey = pRotCurve[n].keyExists(time);
				if(fragRotationP && currKey!=nil)
					pRotCurve[n].deleteKey(currKey);
				
				currKey = bRotCurve[n].keyExists(time);
				if(fragRotationB && currKey!=nil)
					bRotCurve[n].deleteKey(currKey);
					
				currKey = xScaleCurve[n].keyExists(time);
				if(fragScaleX && currKey!=nil)
					xScaleCurve[n].deleteKey(currKey);
					
				currKey = yScaleCurve[n].keyExists(time);
				if(fragScaleY && currKey!=nil)
					yScaleCurve[n].deleteKey(currKey);
					
				currKey = zScaleCurve[n].keyExists(time);
				if(fragScaleZ && currKey!=nil)
					zScaleCurve[n].deleteKey(currKey);
			}
			skipCounter++;
			if(skipCounter>frameSkip)
				skipCounter = 0;
		}
	}
	
	//GoToFrame(startFrame);
}