// Bakes all? types of animation in Layout
// 2009.09.24 first version
//
// Petter Sundnes
// petter@mentalfish.com

@version 2.7
@warnings
@script generic
@asyncspawn
@name MF Keystove

ctlPositionX;
ctlPositionY;
ctlPositionZ;
ctlRotationH;
ctlRotationP;
ctlRotationB;
ctlScaleX;
ctlScaleY;
ctlScaleZ;

ctlPosition;
ctlRotation;
ctlScale;

bakePositionX = 1;
bakePositionY = 1;
bakePositionZ = 1;
bakeRotationH = 1;
bakeRotationP = 1;
bakeRotationB = 1;
bakeScaleX = 1;
bakeScaleY = 1;
bakeScaleZ = 1;

bakePos = 1;
bakeRot = 1;
bakeScl = 1;

toggleXPos: value
{
	bakePositionX = bakePositionX * -1;
	if(bakePositionX == 1 && bakePositionY == 1 && bakePositionZ == 1)
	{
		ctlPosition.value = true;
		bakePos = 1;
	} else {
		ctlPosition.value = false;
		bakePos = -1;
	}
}
toggleYPos: value
{
	bakePositionY = bakePositionY * -1;
	if(bakePositionX == 1 && bakePositionY == 1 && bakePositionZ == 1)
	{
		ctlPosition.value = true;
		bakePos = 1;
	} else {
		ctlPosition.value = false;
		bakePos = -1;
	}

}
toggleZPos: value
{
	bakePositionZ = bakePositionZ * -1;
	if(bakePositionX == 1 && bakePositionY == 1 && bakePositionZ == 1)
	{
		ctlPosition.value = true;
		bakePos = 1;
	} else {
		ctlPosition.value = false;
		bakePos = -1;
	}

}
toggleH: value
{
	bakeRotationH = bakeRotationH * -1;
	if(bakeRotationH == 1 && bakeRotationP == 1 && bakeRotationB == 1)
	{
		ctlRotation.value = true;
		bakeRot = 1;
	} else {
		ctlRotation.value = false;
		bakeRot = -1;
	}
}
toggleP: value
{
	bakeRotationP = bakeRotationP * -1;
	if(bakeRotationH == 1 && bakeRotationP == 1 && bakeRotationB == 1)
	{
		ctlRotation.value = true;
		bakeRot = 1;
	} else {
		ctlRotation.value = false;
		bakeRot = -1;
	}
}
toggleB: value
{
	bakeRotationB = bakeRotationB * -1;
	if(bakeRotationH == 1 && bakeRotationP == 1 && bakeRotationB == 1)
	{
		ctlRotation.value = true;
		bakeRot = 1;
	} else {
		ctlRotation.value = false;
		bakeRot = -1;
	}
}
toggleXScl: value
{
	bakeScaleX = bakeScaleX * -1;
	if(bakeScaleX == 1 && bakeScaleY == 1 && bakeScaleZ == 1)
	{
		ctlScale.value = true;
		bakeScl = 1;
	} else {
		ctlScale.value = false;
		bakeScl = -1;
	}
}
toggleYScl: value
{
	bakeScaleY = bakeScaleY * -1;
	if(bakeScaleX == 1 && bakeScaleY == 1 && bakeScaleZ == 1)
	{
		ctlScale.value = true;
		bakeScl = 1;
	} else {
		ctlScale.value = false;
		bakeScl = -1;
	}
}
toggleZScl: value
{
	bakeScaleZ = bakeScaleZ * -1;
	if(bakeScaleX == 1 && bakeScaleY == 1 && bakeScaleZ == 1)
	{
		ctlScale.value = true;
		bakeScl = 1;
	} else {
		ctlScale.value = false;
		bakeScl = -1;
	}
}

togglePos: value
{
	bakePos = bakePos * -1;
	if(bakePos == 1)
	{
		ctlPositionX.value = true;
		ctlPositionY.value = true;
		ctlPositionZ.value = true;
		bakePositionX = 1;
		bakePositionY = 1;
		bakePositionZ = 1;
	} else if(bakePos == -1) {
		ctlPositionX.value = false;
		ctlPositionY.value = false;
		ctlPositionZ.value = false;
		bakePositionX = -1;
		bakePositionY = -1;
		bakePositionZ = -1;
	}
}
toggleRot: value
{
	bakeRot = bakeRot * -1;
	if(bakeRot == 1)
	{
		ctlRotationH.value = true;
		ctlRotationP.value = true;
		ctlRotationB.value = true;
		bakeRotationH = 1;
		bakeRotationP = 1;
		bakeRotationB = 1;
	} else if(bakeRot == -1) {
		ctlRotationH.value = false;
		ctlRotationP.value = false;
		ctlRotationB.value = false;
		bakeRotationH = -1;
		bakeRotationP = -1;
		bakeRotationB = -1;
	}
}
toggleScl: value
{
	bakeScl = bakeScl * -1;
	if(bakeScl == 1)
	{
		ctlScaleX.value = true;
		ctlScaleY.value = true;
		ctlScaleZ.value = true;
		bakeScaleX = 1;
		bakeScaleY = 1;
		bakeScaleZ = 1;
	} else if(bakeScl == -1){
		ctlScaleX.value = false;
		ctlScaleY.value = false;
		ctlScaleZ.value = false;
		bakeScaleX = -1;
		bakeScaleY = -1;
		bakeScaleZ = -1;
	}
}

generic
{
	reqbegin("MentalFish Keystove");
	reqsize(250,105);
	
	thisScene = Scene(); // Get a reference to the model
	allSceneItems;
	allSceneItems = thisScene.getSelect();
	numberOfItems = sizeof(allSceneItems);
	
	fps = thisScene.fps;
	startTime = thisScene.currenttime;
	startFrame = 0;//startTime*fps;
	
	ctlStartFrame = ctlinteger("Start:", startTime*fps);
	ctlposition(ctlStartFrame,10,5,72,19);
	
	//NextKey();
	endTime = thisScene.frameend/fps;
	ctlEndFrame = ctlinteger("End:", endTime*fps);
	ctlposition(ctlEndFrame,90,5,72,19);
	//GoToFrame(startFrame);

	ctlSkipFrame = ctlinteger("Skip:", 0);
	ctlposition(ctlSkipFrame,170,5,72,19);

	ctlPosition = ctlstate("   Position", true, 100, "togglePos");
	ctlposition(ctlPosition,10,30,73,19);
	ctlPositionX = ctlstate(" X", true, 100, "toggleXPos");
	ctlposition(ctlPositionX,10,48,25,19);
	ctlPositionY = ctlstate(" Y", true, 100, "toggleYPos");
	ctlposition(ctlPositionY,34,48,25,19);
	ctlPositionZ = ctlstate(" Z", true, 100, "toggleZPos");
	ctlposition(ctlPositionZ,58,48,25,19);
	
	ctlRotation = ctlstate("   Rotation", true, 100, "toggleRot");
	ctlposition(ctlRotation,90,30,73,19);
	ctlRotationH = ctlstate(" H", true, 100, "toggleH");
	ctlposition(ctlRotationH,90,48,25,19);
	ctlRotationP = ctlstate(" P", true, 100, "toggleP");
	ctlposition(ctlRotationP,114,48,25,19);
	ctlRotationB = ctlstate(" B", true, 100, "toggleB");
	ctlposition(ctlRotationB,138,48,25,19);
	
	ctlScale = ctlstate("     Scale", true, 100, "toggleScl");
	ctlposition(ctlScale,170,30,73,19);
	ctlScaleX = ctlstate(" X", true, 100, "toggleXScl");
	ctlposition(ctlScaleX,170,48,25,19);
	ctlScaleY = ctlstate(" Y", true, 100, "toggleYScl");
	ctlposition(ctlScaleY,194,48,25,19);
	ctlScaleZ = ctlstate(" Z", true, 100, "toggleZScl");
	ctlposition(ctlScaleZ,218,48,25,19);
	
	return if !reqpost();
		frameStart = getvalue(ctlStartFrame);
		frameEnd = getvalue(ctlEndFrame);
		frameSkip = getvalue(ctlSkipFrame);
		bakePositionX = getvalue(ctlPositionX);
		bakePositionY = getvalue(ctlPositionY);
		bakePositionZ = getvalue(ctlPositionZ);
		bakeRotationH = getvalue(ctlRotationH);
		bakeRotationP = getvalue(ctlRotationP);
		bakeRotationB = getvalue(ctlRotationB);
		bakeScaleX = getvalue(ctlScaleX);
		bakeScaleY = getvalue(ctlScaleY);
		bakeScaleZ = getvalue(ctlScaleZ);
	reqend();
	
	pos[numberOfItems][frameEnd-frameStart] = <0,0,0>;
	rot[numberOfItems][frameEnd-frameStart] = <0,0,0>;
	scl[numberOfItems][frameEnd-frameStart] = <0,0,0>;
	
	frameCount = 0;		
	for(f = frameStart; f <= frameEnd; f++)
	{
		time = f / fps;
		GoToFrame(f);

		RefreshNow(); // Needed to make sure the "state of things" are available

		frameCount++;
		for(itemCnt=1;itemCnt<=numberOfItems;itemCnt++)
		{
			sceneItem = allSceneItems[itemCnt];
			pos[itemCnt][frameCount] = sceneItem.getPosition(time);
			rot[itemCnt][frameCount] = sceneItem.getRotation(time);
			scl[itemCnt][frameCount] = sceneItem.getScaling(time);
			for(chan = sceneItem.firstChannel(); chan != nil; chan = sceneItem.nextChannel())
			{
				if(chan.name == "Position.X")
				    xPosCurve[itemCnt] = chan;
				else if(chan.name == "Position.Y")
				    yPosCurve[itemCnt] = chan;
				else if(chan.name == "Position.Z")
				    zPosCurve[itemCnt] = chan;
				else if(chan.name == "Rotation.H")
				    hRotCurve[itemCnt] = chan;
				else if(chan.name == "Rotation.P")
				    pRotCurve[itemCnt] = chan;
				else if(chan.name == "Rotation.B")
				    bRotCurve[itemCnt] = chan;
				else if(chan.name == "Scale.X")
				    xScaleCurve[itemCnt] = chan;
				else if(chan.name == "Scale.Y")
				    yScaleCurve[itemCnt] = chan;
				else if(chan.name == "Scale.Z")
				    zScaleCurve[itemCnt] = chan;
			}
		}
	}
	for(n = 1; n<=numberOfItems; n++)
	{
		currFrame = 0;
		skipCounter = 0;
		for(f = frameStart;f <= frameEnd;f++)
		{
			time = f / fps;
			currFrame++;
			if(skipCounter==0)
			{
				
				if(bakePositionX)
					xPosCurve[n].createKey(time,pos[n][currFrame].x);
				if(bakePositionY)
					yPosCurve[n].createKey(time,pos[n][currFrame].y);
				if(bakePositionZ)
					zPosCurve[n].createKey(time,pos[n][currFrame].z);
			
				if(bakeRotationH)
					hRotCurve[n].createKey(time,rot[n][currFrame].x);
				if(bakeRotationP)
					pRotCurve[n].createKey(time,rot[n][currFrame].y);
				if(bakeRotationB)
					bRotCurve[n].createKey(time,rot[n][currFrame].z);
				
				if(bakeScaleX)
					xScaleCurve[n].createKey(time,scl[n][currFrame].x);
				if(bakeScaleY)
					yScaleCurve[n].createKey(time,scl[n][currFrame].y);
				if(bakeScaleZ)
					zScaleCurve[n].createKey(time,scl[n][currFrame].z);
			}
			skipCounter++;
			if(skipCounter>frameSkip)
				skipCounter = 0;
		}
	}
	
	GoToFrame(startFrame);
}